"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupGlobal = void 0;
/* eslint-disable no-magic-numbers */
const os_1 = require("os");
const global_1 = __importDefault(require("./global"));
const setupGlobal = () => {
    global_1.default.mockStdout = {
        write: jest.fn(),
    };
    process.stdout.write = global_1.default.mockStdout.write;
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const converter = (prefix = '') => (value) => process.stdout.write(prefix + JSON.stringify(value, null, '\t') + os_1.EOL);
    console.log = jest.fn(converter());
    console.info = jest.fn(converter('__info__'));
    console.error = jest.fn(converter('__error__'));
    console.warn = jest.fn(converter('__warning__'));
    global_1.default.mockChildProcess = {
        stdout: 'stdout',
        stderr: '',
        error: null,
        code: 0,
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        exec: jest.fn((...args) => {
            const callback = args.length === 2 ? args[1] : args[2];
            callback(typeof global_1.default.mockChildProcess.error === 'function' ? global_1.default.mockChildProcess.error(args[0]) : global_1.default.mockChildProcess.error, typeof global_1.default.mockChildProcess.stdout === 'function' ? global_1.default.mockChildProcess.stdout(args[0]) : global_1.default.mockChildProcess.stdout, typeof global_1.default.mockChildProcess.stderr === 'function' ? global_1.default.mockChildProcess.stderr(args[0]) : global_1.default.mockChildProcess.stderr);
        }),
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        spawn: jest.fn((...args) => ({
            stdout: {
                on: (event, callback) => {
                    if (event === 'data') {
                        callback(typeof global_1.default.mockChildProcess.stdout === 'function' ? global_1.default.mockChildProcess.stdout(args[0]) : global_1.default.mockChildProcess.stdout);
                    }
                },
            },
            stderr: {
                on: (event, callback) => {
                    if (event === 'data') {
                        callback(typeof global_1.default.mockChildProcess.stderr === 'function' ? global_1.default.mockChildProcess.stderr(args[0]) : global_1.default.mockChildProcess.stderr);
                    }
                },
            },
            on: (event, callback) => {
                if (event === 'error') {
                    const error = typeof global_1.default.mockChildProcess.error === 'function' ? global_1.default.mockChildProcess.error(args[0]) : global_1.default.mockChildProcess.error;
                    if (error) {
                        callback(error);
                    }
                }
                else if (event === 'close') {
                    callback(typeof global_1.default.mockChildProcess.code === 'function' ? global_1.default.mockChildProcess.code(args[0]) : global_1.default.mockChildProcess.code);
                }
            },
        })),
    };
    jest.mock('child_process', () => (Object.assign(jest.requireActual('child_process'), {
        exec: global_1.default.mockChildProcess.exec,
        spawn: global_1.default.mockChildProcess.spawn,
    })));
    process.env.GITHUB_ACTOR = 'octocat';
    process.env.GITHUB_ENV = '/home/runner/work/_temp/_runner_file_commands/set_env_aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee';
    process.env.GITHUB_PATH = '/home/runner/work/_temp/_runner_file_commands/add_path_aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee';
};
exports.setupGlobal = setupGlobal;
